#!/usr/bin/env python
import time
import RPi.GPIO as GPIO
import pygame,sys
import math
#ADW_PTR7.py
# Programmlisting vom Oktober 2013
# Es laesst sich sicher teilweise noch vereinfachen. 
 
#GPIO-Pins,die mit dem TLC549 verbunden sind
AD_Dat  = 24  # 
AD_Clk = 8
AD_CS = 7   #

#Taster HOLD1, HOLD2,RES
HOLD1=11
HOLD2=10
RES=9

#GPIO-Festlegungen
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
#TLC549
GPIO.setup(AD_CS,GPIO.OUT)
GPIO.setup(AD_Dat,GPIO.IN)
GPIO.setup(AD_Clk,GPIO.OUT)
#HOLD1, HOLD2, RES
GPIO.setup(HOLD1,GPIO.IN)
GPIO.setup(HOLD2,GPIO.IN)
GPIO.setup(RES,GPIO.IN)


def ADein():
	
    GPIO.output(AD_Clk,GPIO.LOW)# AD_Clk auf 0
    AD_res=0
    for n in range(10):
        time.sleep(0.05)        		
        GPIO.output(AD_CS,GPIO.HIGH)# AD_CS auf 1
        MSB=128
        time.sleep(0.001)
        GPIO.output(AD_CS,GPIO.LOW)# AD_CS auf 0
        time.sleep(0.0005)
        AD_Wert=0
        for z in range(8):
            if (GPIO.input(AD_Dat)):
                AD_Wert=AD_Wert+MSB 
            GPIO.output(AD_Clk,GPIO.HIGH)# AD_Clk auf 1
            time.sleep(0.0005)
            GPIO.output(AD_Clk,GPIO.LOW)# AD_Clk auf 0	 
            MSB=MSB>>1
            time.sleep(0.0005)
            Ergebnis=AD_Wert
        GPIO.output(AD_CS,GPIO.HIGH)# AD_CS auf 1    
        AD_res=AD_res+AD_Wert
    AD_res=AD_res/10
    Ergebnis=AD_res    
    return Ergebnis

def Umrechnung(Wert):
    value=Wert
    value=value*1960 #fuer 5V  
    value=value/1000
    pic_value=value/2 #
    einer=value/100
    rest_z=value % 100
    zehntL=rest_z/10
    hundertL=rest_z%10
    return einer, zehntL, hundertL, pic_value,value
    

#Farbendefintionen, kann auf andere Farben erweitert werden
black = (  0,   0,   0)
white = (255, 255, 255)
blue =  (  0,   0, 255)
green = (  0, 255,   0)
red =   (255,   0,   0)
yellow=(255,255,0)
magenta=(255,0,255)
cyan=(0,255,255)
orange=(255,128,64)
brown=(128,64,0)
lilac=(128,0,255)
grey=(192,192,192)

schwarz=(  0,   0,   0)
weiss = (255, 255, 255)
blau =  (  0,   0, 255)
gruen = (  0, 255,   0)
rot =   (255,   0,   0)
gelb=(255,255,0)
#magenta=(255,0,255)
#cyan=(0,255,255)
#orange=(255,128,64)
braun=(128,64,0)
lila=(128,0,255)
grau=(192,192,192)


#Farben und Werte fuer Darstellung eingeben
print
print "*** Hinergrundfarbe ***"
print"black,white,blue,green,red,yellow"
print"magenta,cyan,orange,brown,lilac,grey"
back_col = input("back_col:")
print
print "***Vordergrundfarbe ***"
print"black,white,blue,green,red,yellow"
print"magenta,cyan,orange,brown,lilac,grey"
print
fore_col = input("fore_col:")
print"Bezeichnung der Darstellung"	
Caption_disp=raw_input("Caption_disp: ") 
#Festlegungen: Width:500,Height:380"
print"Faktor fuer Groesse der Darstellung"
dis_f=input("dis_f: ")#Faktor fuer Groesse der Darstellung
#bei einzelnen Faktoren koennen Fehler bei der Darstellung der Skala auftreten
print
pygame.init()
Bereich =pygame.display.set_mode((int(500*dis_f),int(380*dis_f)))
Bereich.fill(back_col)
pygame.display.set_caption(Caption_disp)
#Anfangszustaende
GPIO.output(AD_CS,GPIO.LOW)# AD_CS auf 0
GPIO.output(AD_Clk,GPIO.LOW)# AD_Clk auf 0


while True:
	
    Wert=ADein()
       
    value_tmp=Wert
       
    #Umrechnung(Wert)
    einer,zehntL,hundertL,pic_value,value=Umrechnung(Wert)    
    #Bereich des sich aendernden Anzeigewerts zuerst loeschen
    #                                  
    pygame.draw.rect(Bereich,back_col,(int(165*dis_f),int(295*dis_f),int(175*dis_f),int(60*dis_f)))
    #dann aktuellen Wert darstellen
    meinfont=pygame.font.Font.set_bold
    meinfont=pygame.font.SysFont("COURIERNew",int(40*dis_f))
    #Digitalanzeige     
    label_H=meinfont.render("  "+str(einer)+"."+str(zehntL)+str(hundertL)+"V",1,fore_col)
    #   
    Bereich.blit(label_H,(int(160*dis_f),int(300*dis_f)))#
                  
    # Nun Zeigerdarstellung
        
    x1_zg=int(250*dis_f)  # Anfang des Zeigers
    y1_zg=int(270*dis_f)
    
    #zuerst ganzen Bewegungsbreich des Zeigers (Kreisausschnittsflaeche) loeschen
    for x in range (250):
        Cosinus_L=math.cos(math.pi*x/360+math.pi*27.5/180)
        Sinus_L=math.sin(math.pi*x/360+math.pi*27.5/180)
    #       165 Zeigerlaenge
        lpx=int(165*dis_f*Cosinus_L)#
        lpy=int(165*dis_f*Sinus_L)#
        pygame.draw.line(Bereich,back_col,(x1_zg,y1_zg),(x1_zg-lpx,y1_zg-lpy),1) 	
    
    
    Cosinus=math.cos(math.pi*pic_value/360+math.pi*27.5/180)
    Sinus=math.sin(math.pi*pic_value/360+math.pi*27.5/180)
    #       165 Zeigerlaenge, da Zeiger fuer realistische 
    #       Darstellung in Bereich der Skala hineinragt
    lpx=int(165*dis_f*Cosinus)#
    lpy=int(165*dis_f*Sinus)#
    
    #neue Linie fuer Zeiger zeichnen   Anfang        Ende  
    pygame.draw.line(Bereich,fore_col,(x1_zg,y1_zg),(x1_zg-lpx,y1_zg-lpy),1)   
   
   
   #Skala darstellen
    #kurze Striche
    for k in range(21):
        Cosinus_s=math.cos(12.5*k*math.pi/360+math.pi*27.5/180)
    #Punkt auf Kreisbogen mit Radius 175
        lpx_s=int(175*dis_f*Cosinus_s)
        Sinus_s=math.sin(12.5*k*math.pi/360+math.pi*27.5/180)
        lpy_s=int(175*dis_f*Sinus_s)
        Cosinus=math.cos(12.5*k*math.pi/360+math.pi*27.5/180)
    #Punkt auf Kreisbogen mit Radius 150
        lpx=int(150*dis_f*Cosinus)
        Sinus=math.sin(12.5*k*math.pi/360+math.pi*27.5/180)
        lpy=int(150*dis_f*Sinus)
        #zuerst loeschen, also Linie mit Hintergrundfarbe
        pygame.draw.line(Bereich,back_col,(x1_zg-lpx_s,y1_zg-lpy_s),(x1_zg-lpx,y1_zg-lpy),1)
        #dann darstellen, nun Linie mit Vordergrundfarbe 
        pygame.draw.line(Bereich,fore_col,(x1_zg-lpx_s,y1_zg-lpy_s),(x1_zg-lpx,y1_zg-lpy),1) 
    #lange Striche 
    for k in range(6):
        Cosinus_s=math.cos(50*k*math.pi/360+math.pi*27.5/180)
    #Punkt auf Kreisbogen mit Radius 185    
        lpx_s=int(185*dis_f*Cosinus_s)
        Sinus_s=math.sin(50*k*math.pi/360+math.pi*27.5/180)
        lpy_s=int(185*dis_f*Sinus_s)
        Cosinus=math.cos(50*k*math.pi/360+math.pi*27.5/180)
     #Punkt auf Kreisbogen mit Radius 150
        lpx=int(150*dis_f*Cosinus)
        Sinus=math.sin(50*k*math.pi/360+math.pi*27.5/180)
        lpy=int(150*dis_f*Sinus)
        
        
        #dann darstellen, nun Linie mit Vordergrundfarbe zeichnen
        pygame.draw.line(Bereich,fore_col,(x1_zg-lpx_s,y1_zg-lpy_s),(x1_zg-lpx,y1_zg-lpy),1) 
    
    if (GPIO.input(HOLD1)==0):	 
        #min-Anzeige wie "Hauptanzeige" unten in der Mitte 
        
        Wert=value_tmp
        einer,zehntL,hundertL,pic_value,value=Umrechnung(Wert) 
        #zuerst Teilbereich loeschen, in dem Anzeige erfolgt        
        #                               
        pygame.draw.rect(Bereich,back_col,(int(25*dis_f),int(300*dis_f),int(120*dis_f),int(60*dis_f)))
        #dann in geringerer Schrifthoehe als "Hauptwert" darstellen   
        meinfont=pygame.font.SysFont("COURIERNew",int(30*dis_f))  
        label_min=meinfont.render(str(einer)+"."+str(zehntL)+str(hundertL)+"V",1,fore_col)
        Bereich.blit(label_min,(int(40*dis_f),int(320*dis_f)))
        einer,zehntL,hundertL,pic_value,value=Umrechnung(Wert) 
        
   #Markierung1
        mark_value=pic_value
    
    #Cosinus und Sinus vom Zeiger verwenden, da gleicher Winkel  
    #wie Zeiger
        Cosinus=math.cos(math.pi*pic_value/360+math.pi*27.5/180)
        Sinus=math.sin(math.pi*pic_value/360+math.pi*27.5/180)
     #Punkt auf Kreisbogen mit Radius 160   
        lpx=int(160*dis_f*Cosinus)
        lpy=int(160*dis_f*Sinus)
     #Punkt auf Kreisbogen mit Radius 210   
        lpx1_m=int(210*dis_f*Cosinus)
        lpy1_m=int(210*dis_f*Sinus)
     #Punkt auf kreisbogen mit Radius 190  
        lpx2_m=int(190*dis_f*Cosinus)
        lpy2_m=int(190*dis_f*Sinus)
    #Linie fuer Markierung zeichnen                                      
        pygame.draw.line(Bereich,fore_col,(x1_zg-lpx1_m,y1_zg-lpy1_m),(x1_zg-lpx2_m,y1_zg-lpy2_m),1)   
       
    
    if (GPIO.input(HOLD2)==0):     
        #max-Anzeige wie "Hauptanzeige"
        
        Wert=value_tmp
        einer,zehntL,hundertL,pic_value,value=Umrechnung(Wert) 
        #zuerst Teilbereich loeschen, indem Anzeige erfolgt 
        #                               
        pygame.draw.rect(Bereich,back_col,(int(360*dis_f),int(300*dis_f),int(120*dis_f),int(60*dis_f)))
        #dann in geringerer Schrifthoehe als "Hauptwert"darstellen
        #                               
        meinfont=pygame.font.SysFont("COURIERNew",int(30*dis_f))  
        label_max=meinfont.render(str(einer)+"."+str(zehntL)+str(hundertL)+"V",1,fore_col)
        Bereich.blit(label_max,(int(370*dis_f),int(320*dis_f)))#war 40,30        
        Wert=value_tmp
        einer,zehntL,hundertL,pic_value,value=Umrechnung(Wert) 
    
        mark_value=pic_value
        #Markierung2
        #Cosinus und Sinus vom Zeiger verwenden, da gleicher Winkel 
        #wie Zeiger
        Cosinus=math.cos(math.pi*pic_value/360+math.pi*27.5/180)
        Sinus=math.sin(math.pi*pic_value/360+math.pi*27.5/180)
    #Punkt auf Kreisbogen mit Radius 160
        lpx=int(160*dis_f*Cosinus)
        lpy=int(160*dis_f*Sinus)
    #Punkt auf Kreisbogen mit Radius 210     
        lpx1_m=int(210*dis_f*Cosinus)#210
        lpy1_m=int(210*dis_f*Sinus)
    #Punkt auf Kreisbogen mit Radius 190    
        lpx2_m=int(190*dis_f*Cosinus)#190
        lpy2_m=int(190*dis_f*Sinus)
    #Linie fuer Markierung zeichnen           
        pygame.draw.line(Bereich,fore_col,(x1_zg-lpx1_m,y1_zg-lpy1_m),(x1_zg-lpx2_m,y1_zg-lpy2_m),1)   
       
    if (GPIO.input(RES)==0):
	#Zuerst kompletten Teil einer Kreisringflaeche, in dem
	#sich die Markierungen befinden,loeschen  	
        for x in range (250):
            Cosinus_ML=math.cos(math.pi*x/360+math.pi*27.5/180)
            Sinus_ML=math.sin(math.pi*x/360+math.pi*27.5/180)
            #lpx=int(160*dis_f*Cosinus)
            #lpy=int(160*dis_f*Sinus)
            lpx1_ML=int(210*dis_f*Cosinus_ML)
            lpy1_ML=int(210*dis_f*Sinus_ML)
            lpx2_ML=int(190*dis_f*Cosinus_ML)
            lpy2_ML=int(190*dis_f*Sinus_ML)
          # Markierungsbereich ganz loeschen        
            pygame.draw.line(Bereich,back_col,(x1_zg-lpx1_ML,y1_zg-lpy1_ML),(x1_zg-lpx2_ML,y1_zg-lpy2_ML),1)   
       	
       	    # Darstellungsbereich fuer linken Wert loeschen
       	    #                               
        pygame.draw.rect(Bereich,back_col,(int(25*dis_f),int(300*dis_f),int(120*dis_f),int(60*dis_f)))
             
            # Darstellungsbereich fuer rechten Wert loeschen
            #                               
        pygame.draw.rect(Bereich,back_col,(int(360*dis_f),int(300*dis_f),int(120*dis_f),int(60*dis_f)))
         
                
    pygame.display.update()
    
    
    
GPIO.Cleanup()	
