#!/usr/bin/env python
import time
import RPi.GPIO as GPIO
import pygame,sys
import math
#ADW_SK9.py

# Programmlisting vom  Oktober 2013
# laesst sich sicher teilweise noch vereinfachen.

#GPIO-Pins
#TLC549 
AD_Dat  = 24  # 
AD_Clk = 8
AD_CS = 7   #
#Taster HOLD1, HOLD2,RES
HOLD1=11
HOLD2=10
RES=9



#GPIO-Festlegungen
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
#TLC549
GPIO.setup(AD_CS,GPIO.OUT)
GPIO.setup(AD_Dat,GPIO.IN)
GPIO.setup(AD_Clk,GPIO.OUT)
#HOLD1,HOLD2,RES
GPIO.setup(HOLD1,GPIO.IN)
GPIO.setup(HOLD2,GPIO.IN)
GPIO.setup(RES,GPIO.IN)



def ADein():
    GPIO.output(AD_Clk,GPIO.LOW)# AD_Clk auf 0
    AD_res=0
    for n in range(10): 
        time.sleep(0.05)        		
        GPIO.output(AD_CS,GPIO.HIGH)# AD_CS auf 1
        MSB=128
        time.sleep(0.001)
        GPIO.output(AD_CS,GPIO.LOW)# AD_CS auf 0
        time.sleep(0.0005)
        AD_Wert=0
        for z in range(8):
            if (GPIO.input(AD_Dat)):
                AD_Wert=AD_Wert+MSB 
            GPIO.output(AD_Clk,GPIO.HIGH)# AD_Clk auf 1
            time.sleep(0.0005)
            GPIO.output(AD_Clk,GPIO.LOW)# AD_Clk auf 0	 
            MSB=MSB>>1
            time.sleep(0.0005)
            Ergebnis=AD_Wert
        GPIO.output(AD_CS,GPIO.HIGH)# AD_CS auf 1    
        AD_res=AD_res+AD_Wert
    AD_res=AD_res/10
    Ergebnis=AD_res    
    return Ergebnis
	
      
    
def Umrechnung(Wert):
    value=Wert
    value=value*1960 #fuer 5V  
    value=value/1000
    pic_value=value/2 #fuer Bargraphdarstellung
    einer=value/100
    rest_z=value % 100
    zehntL=rest_z/10
    hundertL=rest_z%10
    return einer, zehntL, hundertL, pic_value,value
    


# Farbendefinitionen
# kann auf andere Farben erweitert werden
black = (  0,   0,   0)
white = (255, 255, 255)
blue =  (  0,   0, 255)
green = (  0, 255,   0)
red =   (255,   0,   0)
yellow=(255,255,0)
magenta=(255,0,255)
cyan=(0,255,255)
orange=(255,128,64)
brown=(128,64,0)
lilac=(128,0,255)
grey=(192,192,192)

schwarz = (  0,   0,   0)
weiss = (255, 255, 255)
blau =  (  0,   0, 255)
gruen = (  0, 255,   0)
rot =   (255,   0,   0)
gelb=(255,255,0)
#magenta=(255,0,255)
#cyan=(0,255,255)
#orange=(255,128,64)
braun=(128,64,0)
lila=(128,0,255)
grau=(192,192,192)

#Farben und Werte fuer Darstellung eingeben
print
print "*** Hintergrundfarbe ***"
print"black,white,blue,green,red,yellow"
print"magenta,cyan,orange,brown,lilac,grey"
back_col = input("back_col:")
print
print "*** Vordergrundfarbe ***"
print"black,white,blue,green,red,yellow"
print"magenta,cyan,orange,brown,lilac,grey"
print
fore_col = input("fore_col:")	
Caption_disp=raw_input("Caption_disp: ") 
# Width:480,Height:150
dis_f=input("dis_f: ")# Faktor fuer Groesse der Darstellung
#bei einzelnen Faktoren koennen Fehler bei der Darstellung der Skala auftreten
print
pygame.init()                       # 480
Bereich =pygame.display.set_mode((int(480*dis_f),int(150*dis_f))) 
Bereich.fill(back_col)
pygame.display.set_caption(Caption_disp)

#Anfangszustaende
GPIO.output(AD_CS,GPIO.HIGH)# AD_CS auf 1
GPIO.output(AD_Clk,GPIO.LOW)# AD_Clk auf 0

while True:
    Wert=ADein()
    
    value_tmp=Wert
    #Umrechnung(Wert)
    einer,zehntL,hundertL,pic_value,value=Umrechnung(Wert)    
    #Bereich fuer sich aendernden Anzeigewert zuerst loeschen
    #                               
    pygame.draw.rect(Bereich,back_col,(int(145*dis_f),int(100*dis_f),int(175*dis_f),int(60*dis_f)))#war: 40,30,80,30
    #dann Wert mit Einhait darstellen
    meinfont=pygame.font.Font.set_bold
    meinfont=pygame.font.SysFont("COURIERNew",int(40*dis_f))
    #Digitalanzeige       
    labelWert=meinfont.render("  "+str(einer)+"."+str(zehntL)+str(hundertL)+"V",1,fore_col)
    Bereich.blit(labelWert,(int(140*dis_f),int(100*dis_f)))
         
    
    if  (GPIO.input(HOLD1)==0):	
        #"Min-Anzeige" wie Hauptanzeige 
        
        Wert=value_tmp
        einer,zehntL,hundertL,pic_value,value=Umrechnung(Wert)
        #Markierung setzen                
        pygame.draw.line(Bereich,fore_col,(int(dis_f*130)+int(dis_f*pic_value),int(dis_f*5)),(int(dis_f*130)+int(dis_f*pic_value),int(dis_f*25)),1)
        
        #zuerst Teilbereich loeschen        
        #                               
        pygame.draw.rect(Bereich,back_col,(int(40*dis_f),int(110*dis_f),int(120*dis_f),int(40*dis_f)))
        #dann darstellen   
        meinfont=pygame.font.SysFont("COURIERNew",int(30*dis_f))  
        labelWert=meinfont.render(str(einer)+"."+str(zehntL)+str(hundertL)+"V",1,fore_col)
        Bereich.blit(labelWert,(int(40*dis_f),int(110*dis_f)))
        einer,zehntL,hundertL,pic_value,value=Umrechnung(Wert) 
        
    if (GPIO.input(HOLD2)==0):     
        #"Max-Anzeige" wie Hauptanzeige
        Wert=value_tmp
        einer,zehntL,hundertL,pic_value,value=Umrechnung(Wert) 
        #Markierung "setzen"                                                                                  
        pygame.draw.line(Bereich,fore_col,(int(dis_f*130)+int(dis_f*pic_value),int(dis_f*5)),(int(dis_f*130)+int(dis_f*pic_value),int(dis_f*25)),1)
        #zuerst Teilbereich loeschen
        #                               
        pygame.draw.rect(Bereich,back_col,(int(370*dis_f),int(110*dis_f),int(120*dis_f),int(40*dis_f)))
        #dann darstellen
        meinfont=pygame.font.SysFont("COURIERNew",int(30*dis_f))  
        labelWert=meinfont.render(str(einer)+"."+str(zehntL)+str(hundertL)+"V",1,fore_col)
        Bereich.blit(labelWert,(int(370*dis_f),int(110*dis_f)))
    
    if (GPIO.input(RES)==0):  
        #Bereich fuer Markierungen loeschen
        pygame.draw.rect(Bereich,back_col,(int(5*dis_f),int(5*dis_f),int(400*dis_f),int(25*dis_f)))
               
        # Bereich fuer "Min-Anzeige" loeschen
        #                                  
        pygame.draw.rect(Bereich,back_col,(int(40*dis_f),int(100*dis_f),int(120*dis_f),int(40*dis_f)))
        # Bereich fuer "Max-Anzeige" loeschen
        pygame.draw.rect(Bereich,back_col,(int(370*dis_f),int(100*dis_f),int(120*dis_f),int(40*dis_f)))
                   
        Wert=value_tmp
        einer,zehntL,hundertL,pic_value,value=Umrechnung(Wert) 
        
         
       #Nun Skala darstellen
       # zuerst kurze Striche 
    for M in range(25):
		       #                                                                                 
        pygame.draw.line(Bereich,fore_col,(int(dis_f*130)+M*int(dis_f*10),int(dis_f*65)),(int(dis_f*130)+M*int(dis_f*10),int(dis_f*80)),1)
       # danach lange Striche
    for L in range(6):
		                                                                                                 
        pygame.draw.line(Bereich,fore_col,(int(dis_f*130)+L*int(dis_f*50),int(dis_f*65)),(int(dis_f*130)+L*int(dis_f*50),int(dis_f*90)),1)
    
    #Bereich zuerst vollstaendig loeschen  X-Koordinate   Y-Koordinate    Breite     Hoehe   
    pygame.draw.rect(Bereich,back_col,(int(dis_f*130),int(dis_f*30),int(dis_f*255),int(dis_f*30)))
    pygame.draw.rect(Bereich,fore_col,(int(dis_f*130),int(dis_f*30),int(dis_f*253),int(dis_f*30)),1)
    #dann farbige Flaeche  zeichnen 
    #dann farbige Flaeche  zeichnen 
    pygame.draw.rect(Bereich,fore_col,(int(dis_f*130),int(dis_f*30),int(dis_f*pic_value),int(dis_f*30))) 
    
       
    pygame.display.update()
    

GPIO.Cleanup()	    
