#!/usr/bin/env python
import time
import RPi.GPIO as GPIO
import pygame,sys
import math
#ADW_SK9.py

#version of october 2013
#source code can probably be simplified 
 

#GPIO-Pins connected to the TLC549
#TLC549 
AD_Dat  = 24  # 
AD_Clk = 8
AD_CS = 7   #
#buttons HOLD1, HOLD2,RES
HOLD1=11
HOLD2=10
RES=9

#GPIO definitions
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
#TLC549
GPIO.setup(AD_CS,GPIO.OUT)
GPIO.setup(AD_Dat,GPIO.IN)
GPIO.setup(AD_Clk,GPIO.OUT)
#HOLD1,HOLD2,RES
GPIO.setup(HOLD1,GPIO.IN)
GPIO.setup(HOLD2,GPIO.IN)
GPIO.setup(RES,GPIO.IN)



def ADin():
    GPIO.output(AD_Clk,GPIO.LOW)# AD_Clk auf 0
    AD_res=0
    for n in range(10): 
        time.sleep(0.05)        		
        GPIO.output(AD_CS,GPIO.HIGH)# AD_CS auf 1
        MSB=128
        time.sleep(0.001)
        GPIO.output(AD_CS,GPIO.LOW)# AD_CS auf 0
        time.sleep(0.0005)
        AD_value0=0
        for z in range(8):
            if (GPIO.input(AD_Dat)):
                AD_value0=AD_value0+MSB 
            GPIO.output(AD_Clk,GPIO.HIGH)# AD_Clk auf 1
            time.sleep(0.0005)
            GPIO.output(AD_Clk,GPIO.LOW)# AD_Clk auf 0	 
            MSB=MSB>>1
            time.sleep(0.0005)
            Ergebnis=AD_value0
        GPIO.output(AD_CS,GPIO.HIGH)# AD_CS auf 1    
        AD_res=AD_res+AD_value0
    AD_res=AD_res/10
    Ergebnis=AD_res    
    return Ergebnis
	
      
    
def conversion(value0):
    value=value0
    value=value*1960 #fuer 5V  
    value=value/1000
    pic_value=value/2 #fuer Bargraphdarstellung
    one=value/100
    rest_z=value % 100
    tenth=rest_z/10
    hundreth=rest_z%10
    return one, tenth, hundreth, pic_value,value
    

#Color definitions can be extended for other colors
black = (  0,   0,   0)
white = (255, 255, 255)
blue =  (  0,   0, 255)
green = (  0, 255,   0)
red =   (255,   0,   0)
yellow=(255,255,0)
magenta=(255,0,255)
cyan=(0,255,255)
orange=(255,128,64)
brown=(128,64,0)
lilac=(128,0,255)
grey=(192,192,192)


#Enter the colors and values for the representation
print
print "*** background color ***"
print"black,white,blue,green,red,yellow"
print"magenta,cyan,orange,brown,lilac,grey"
back_col = input("back_col:")
print
print "*** foreground color ***"
print"black,white,blue,green,red,yellow"
print"magenta,cyan,orange,brown,lilac,grey"
print
fore_col = input("fore_col:")	
print
Caption_disp=raw_input("Caption_disp: ") 
#definitions for width and height:
#Width:480,Height:150
print
print"factor for the size of the representation"
dis_f=input("dis_f: ")#
#at a few factors errors in the presentation of the scale may occur
print
pygame.init()
area =pygame.display.set_mode((int(480*dis_f),int(150*dis_f)))
area.fill(back_col)
pygame.display.set_caption(Caption_disp)
#first logical states
GPIO.output(AD_CS,GPIO.LOW)# AD_CS auf 0
GPIO.output(AD_Clk,GPIO.LOW)# AD_Clk auf 0



while True:
    value0=ADin()
    
    value_tmp=value0
    #conversion(value0)
    one,tenth,hundreth,pic_value,value=conversion(value0)    
    #first delete the area of the changing display value 
    #                               
    pygame.draw.rect(area,back_col,(int(145*dis_f),int(100*dis_f),int(175*dis_f),int(60*dis_f)))#war: 40,30,80,30
    #represent the current value
    m_font=pygame.font.Font.set_bold
    m_font=pygame.font.SysFont("COURIERNew",int(40*dis_f))
    #digital display       
    labelvalue0=m_font.render("  "+str(one)+"."+str(tenth)+str(hundreth)+"V",1,fore_col)
    area.blit(labelvalue0,(int(140*dis_f),int(100*dis_f)))
         
    
    if  (GPIO.input(HOLD1)==0):	
        #"min display"
        
        value0=value_tmp
        one,tenth,hundreth,pic_value,value=conversion(value0)
        #set marker                
        pygame.draw.line(area,fore_col,(int(dis_f*130)+int(dis_f*pic_value),int(dis_f*5)),(int(dis_f*130)+int(dis_f*pic_value),int(dis_f*25)),1)
        
        #first delete subarea       
        #                               
        pygame.draw.rect(area,back_col,(int(40*dis_f),int(110*dis_f),int(120*dis_f),int(40*dis_f)))
        #now drawing  
        m_font=pygame.font.SysFont("COURIERNew",int(30*dis_f))  
        labelvalue0=m_font.render(str(one)+"."+str(tenth)+str(hundreth)+"V",1,fore_col)
        area.blit(labelvalue0,(int(40*dis_f),int(110*dis_f)))
        one,tenth,hundreth,pic_value,value=conversion(value0) 
        
    if (GPIO.input(HOLD2)==0):     
        #"max display"
        value0=value_tmp
        one,tenth,hundreth,pic_value,value=conversion(value0) 
        #set marker                                                                                  
        pygame.draw.line(area,fore_col,(int(dis_f*130)+int(dis_f*pic_value),int(dis_f*5)),(int(dis_f*130)+int(dis_f*pic_value),int(dis_f*25)),1)
        #first clear subarea
        #                               
        pygame.draw.rect(area,back_col,(int(370*dis_f),int(110*dis_f),int(120*dis_f),int(40*dis_f)))
        #now drawing
        m_font=pygame.font.SysFont("COURIERNew",int(30*dis_f))  
        labelvalue0=m_font.render(str(one)+"."+str(tenth)+str(hundreth)+"V",1,fore_col)
        area.blit(labelvalue0,(int(370*dis_f),int(110*dis_f)))
    
    if (GPIO.input(RES)==0):  
        #clear area for markers
        pygame.draw.rect(area,back_col,(int(5*dis_f),int(5*dis_f),int(400*dis_f),int(25*dis_f)))
               
        # clear area for "min display"
        #                                  
        pygame.draw.rect(area,back_col,(int(40*dis_f),int(100*dis_f),int(120*dis_f),int(40*dis_f)))
        # clear area for "max display"
        pygame.draw.rect(area,back_col,(int(370*dis_f),int(100*dis_f),int(120*dis_f),int(40*dis_f)))
                   
        value0=value_tmp
        one,tenth,hundreth,pic_value,value=conversion(value0) 
        
         
       #represent scale
       # short strokes 
    for M in range(25):
		       #                                                                                 
        pygame.draw.line(area,fore_col,(int(dis_f*130)+M*int(dis_f*10),int(dis_f*65)),(int(dis_f*130)+M*int(dis_f*10),int(dis_f*80)),1)
       # long strokes
    for L in range(6):
		                                                                                                 
        pygame.draw.line(area,fore_col,(int(dis_f*130)+L*int(dis_f*50),int(dis_f*65)),(int(dis_f*130)+L*int(dis_f*50),int(dis_f*90)),1)
    
    #clear the whole area  
    pygame.draw.rect(area,back_col,(int(dis_f*130),int(dis_f*30),int(dis_f*255),int(dis_f*30)))
    pygame.draw.rect(area,fore_col,(int(dis_f*130),int(dis_f*30),int(dis_f*253),int(dis_f*30)),1)
    
    #draw colored surface that corresponds to the measured value
    
    pygame.draw.rect(area,fore_col,(int(dis_f*130),int(dis_f*30),int(dis_f*pic_value),int(dis_f*30))) 
    
       
    pygame.display.update()
    

GPIO.Cleanup()	    
